%basic satchmo

satisfiable :-
	findall(Clause, violated_instance(Clause), Set),
	not (Set =[]),!,
	satisfy_all(Set),
	satisfiable.
satisfiable.

violated_instance(B ---> H):-
	(B ---> H), B, not(H).

satisfy_all([]).
satisfy_all([_B ---> H | Tail]):-
	H, !, satisfy_all(Tail).
satisfy_all([_B ---> H | Tail]):-
	satisfy(H), satisfy_all(Tail).

satisfy(E):-
	component(Atom, E), not(Atom = false),
	assume(Atom).

component(Atom, (Atom ; _Rest)).
component(Atom, (_ ; Rest)):-
	!, component(Atom,Rest).
component(Atom, Atom).

assume(Atom):-
	asserta(Atom).
assume(Atom):-
	once(retract(Atom)),
	fail.


