import java.util.*;

/**
 *Der Rumpf der Klausel
 *<p>
 *Siehe auch <a href="SatchParserBNF.html"><b>SatchParserBNF.html</b></a>.
 */
class Body{

  private Vector atome;
  private Vector atomClone=null;

  Body(Vector at){
    atome =at;
  }

  Body(Object o){
    atome = new Vector();
    atome.addElement(o);
  }

  Vector internVars(Vector v){
    for(int i=atome.size()-1;i>-1;i--){

      v = ((Atom)atome.elementAt(i)).internVars(v);
    }
    return v;
  }

  void cloneYourValue(){

    atomClone = (Vector) atome.clone();

    for(int i= atome.size()-1;i>-1;i--){
      ((Atom) atome.elementAt(i)).cloneYourValue();
    }
  }

  Body clonedValue(){
    for(int i= atome.size()-1;i>-1;i--){
      atomClone.setElementAt(((Atom) atome.elementAt(i)).clonedValue(), i);
    }
    return new Body(atomClone);
  }

  void unbind(){
    for(int i= atome.size()-1;i>-1;i--){    
      ((Atom) atome.elementAt(i)).unbind();
    }
  }


  Vector getAtoms(){
    return atome;
  }


  public boolean equals(Object o){
    if(o instanceof Body){
      Vector v = ((Body) o).getAtoms();

      if(v.size() != atome.size()) 
	return false;

      for(int i=v.size()-1;i>-1;i--)
	if(!v.elementAt(i).equals(atome.elementAt(i)))
	  return false;

      return true;
    }
    return false;
  }


  public String toString(){
    StringBuffer buf = new StringBuffer();

    if(atome.size() >0) 
      buf.append(atome.elementAt(0).toString());

    for(int i=1; i < atome.size();i++)
      buf.append(", "+atome.elementAt(i).toString());

    return buf.toString();
  }
}
