import java.util.*;

/**
 *Eine Cipher ist einfach eine Zahl.
 *<p>
 *Siehe auch <a href="SatchParserBNF.html"><b>SatchParserBNF.html</b></a>.
 */    
//Number und Integer sind schon in java.lang belegt!
class Cipher extends Term{

  private Integer cipher;
  private Cipher klon;


  Cipher(Integer i){
    this.cipher = i;
  }

  /**
   *Eine Cipher matcht entweder eine gleiche Cipher oder eine Variable.
   *Eine Variable wird genau dann gematcht, wenn die Variable die Cipher matcht.
   *(Denn nur die Variable wei, ob sie gebunden ist.)
   */
  public boolean matches(Term t, Compound comp){
    if(t instanceof Var){
      return ((Var)t).matches(this, comp);
    }

    if(t instanceof Cipher)
      return this.equals(t); //eigentlich wre auch this == t mglich

    else return false;
  }

  public boolean equals(Object o){
    if(o instanceof Cipher){
      Cipher z = (Cipher) o;
      return z.intValue() == cipher.intValue();
    }
    else return false;
  }

  int intValue(){
    return cipher.intValue();
  }

  /**
   * @see Var
   */
  Term value(){
    return this;
  }


  void cloneYourValue(){
    /*klon = new Cipher(cipher)*/ //Sharing!
    int ms = 3+7; //microsoft liebt 'pure virtual function calls' !!
  }

  public Term clonedValue(){/*
    if(klon != null)//klon existiert
      return klon;
    else
      throw new NoSuchElementException();
      */
    return this; //Sharing!
  }


  void unbind(Compound comp){
    klon = null;
  }

  //Dummie-Methode. Wenn sie aber gar nichts macht, bekommt man von
  //manchen C-libraries eine 'pure virtual funktion call'-Exception.
  //(Frag nicht von welchen!)
  void limitedUnbind(Compound from){
    int ms = 3+7;
  }

  public String toString(){
    return ""+cipher.intValue();
      }
  
}
