import java.util.*;
/**
 *Imitation einer Prolog-Database.
 */
class DataBase{

  private Hashtable hashtable = new Hashtable();
  java.io.PrintStream o = System.out;

  //Kein expliziter Konstruktor;



  void assert(Atom at){

    if(!hashtable.containsKey(at.predicate())){

      Vector v = new Vector();
      v.addElement(at);

      hashtable.put(at.predicate(), v);
    }
    else{
      Vector v =(Vector) hashtable.get(at.predicate());
      v.addElement(at);
    }
  }//assert Atom


  void retract(Atom at){
    try{
    
      Vector v = (Vector) hashtable.get(at.predicate());
      v.removeElement(at);

    }catch(NullPointerException ex){ex.printStackTrace();}
    
  }//retract Atom


  /**
   *berprft ob eines der in einem Vector bergebenen Atome in der 
   *DataBase enthalten ist.
   */
  boolean containsOneOf(Vector atoms){

  counter: for(int i=atoms.size()-1;i>-1;i--){

    Atom a = (Atom) atoms.elementAt(i);
    Vector v = (Vector) hashtable.get(a.predicate());

    if(v == null) continue counter;

    if(v.contains(a)) return true;
  }//counter
  return false;
  }


  /**
   *berprft ob die in der AtomList bergebenen Atome in der 
   *DataBase enthalten sind.
   */
  boolean contains(AtomList atoms){

    Atom[] arr = atoms.getAtoms();
    
    for(int i=0; i<arr.length; i++){
      Atom a = (Atom) arr[i];
      Vector v = (Vector) hashtable.get(a.predicate());

      if(v == null || !v.contains(a)) return false;
    }
    return true;
  }


  /**
   *berprft ob das bergebene Atom in der 
   *DataBase enthalten ist.
   */
  boolean contains(Atom a){

    Vector v = (Vector) hashtable.get(a.predicate());
    
    if(v != null && v.contains(a)) return true;
    
    return false;
  }
	  
  /**
   *berprft welche der in einem Vector bergebenen Atome in der 
   *DataBase enthalten sind, und gibt sie dann zurueck.
   */
    Vector selectContainedAtoms(Vector atoms){
      Vector selected = new Vector();

  counter: for(int i=atoms.size()-1;i>-1;i--){

    Atom a = (Atom) atoms.elementAt(i);
    Vector v = (Vector) hashtable.get(a.predicate());

    if(v == null) continue counter;

    if(v.contains(a)) selected.addElement(a);
  }//counter
  return selected;
    }
	  

  /**
   *Ueberprueft welche bereits gefundene Modelle in der DataBase enthalten
   *sind, und gibt sie dann zurueck.
   */
  public Vector selectContainedModels(Vector models){

    Vector selected = new Vector();

    for(int i=models.size()-1;i>-1;i--){

	AtomList model = (AtomList) models.elementAt(i);
	if(this.contains(model))

	selected.addElement(model);
    }
    return selected;
  }


  /**
   *Gibt fr jede gefundene Instanz einen Array von gebundenen Variablen zurck. 
   *Das gestattet spter ein einfaches Einsetzen der Variablen-Belegungen in die 
   *richtigen Variablen (es werden ja sowohl die Variablen selbst, als auch deren
   *Wert zurckgegeben).
   */
  Vector getSubstList(Atom at){

    Compound comp = at.getCompound();
    Vector v = (Vector) hashtable.get(comp.predicate());

    //wenn das Atom nicht in der hashtable ist, ist v == null
    if(v==null)return new Vector();

    Vector results = new Vector();

    //fr jeden Eintrag in der db wollen wir alle Substitutionen
    for(int i=v.size()-1;i>-1;i--){
      Term[] substitution = ((Atom)v.elementAt(i)).getCompound().getSubstitutions(comp);

      if(substitution != null)
	results.addElement(substitution);
    }
    return results;

  }//getSubstList
   

  /**
   *Gibt alle derzeit in der DataBase enthaltenen Atomlisten aus.
   */
  public Enumeration getCompoundLists(){
    return hashtable.elements();
  }

  /**
   *Gibt alle derzeit in der DataBase enthaltenen Atome aus.
   */
  public Vector getAtoms(){
    Vector atoms = new Vector();
    Enumeration enu = hashtable.elements();

    while(enu.hasMoreElements()){
      Vector v = (Vector) enu.nextElement();
      
      for(int i = v.size()-1;i>-1;i--)
	atoms.addElement(v.elementAt(i));
    }
    return atoms;
  }


  /**
   *Schreibt alle derzeit in der DataBase enthaltenen Atome in eine AtomList.
   */
  public AtomList getAtoms2(){

    AtomList atoms = new AtomList();
    Enumeration enu = hashtable.elements();

    while(enu.hasMoreElements()){
      Vector v = (Vector) enu.nextElement();
      
      for(int i = v.size()-1;i>-1;i--)
	atoms.add((Atom) v.elementAt(i));
    }
   return atoms;   
  }


  /**
   *Gibt den Inhalt der DB in etwas schnerer Form als 
   *<code>toString()</code> aus.
   */
  public void print(){
    Enumeration enu = hashtable.elements();

    while(enu.hasMoreElements()){
      Vector v = (Vector) enu.nextElement();
      
      for(int i = v.size()-1;i>-1;i--)
	o.println("\t"+v.elementAt(i));
    }
  }
    

  public String toString(){
    return hashtable.toString();
  }

}//class
