/**
 *Enthlt Heads und Nullpointer oder Strings, und sortiert die Heads nach 
 *ihrer Lnge.
 *
 *Dabei kommen die kleinsten Heads vor den greren. Die Strings 
 *sind nur enthalten, wenn die trace-Option eingeschaltet ist. In diesem Fall 
 *reprsentieren sie 'false' bzw. 'null', und enthalten ein Abbild der
 *angewandten Regelinstanz.
 */
public final class DoubleQueue {

  private Head[] elems;
  private Object[] strings;
  private int elementCount;
  private int stringCount;


  public DoubleQueue(){ elems = new Head[10];strings = new Object[10]; }

  public final void empty(){
   elems = new Head[10]; elementCount = 0;
   strings = new Object[10]; stringCount = 0;
  }

  /**
   *Sortiert einkommende Heads nach Lnge. 
   *
   *Wenn Strings kommen, werden sie in einen separaten Array gespeichert.
   */
  public final void enqueue(Object o){

    if(o instanceof String){
      if(strings.length == stringCount){
	Object[] help = new Object[stringCount+10];
	System.arraycopy(strings, 0, help, 0, stringCount);
	strings = help; help = null;
      }
      strings[stringCount++]=o;
    }
    else{//also Head oder null
      if(elems.length == elementCount){
	Head[] help = new Head[elementCount+10];
	System.arraycopy(elems, 0, help, 0, elementCount);
	elems = help; help = null;
      }
      if(o == null){
	System.arraycopy(elems, 0, elems, 1, elementCount);
	elems[0] = null;
	elementCount++;
      }
      else{
	Head h= (Head) o;

	if(elementCount ==0){ elems[0]= h; elementCount++;}
	else{

	  for(int i=0; i<elementCount; i++){
	    if(elems[i]==null || elems[i].size() <= h.size());//mach nix
	    else{
	      System.arraycopy(elems, i, elems, i+1, elementCount-i+1);
	      elems[i] = h;
	      elementCount++;
	      break;
	    }//else
	  }//for
	}//elemntCount !=0
      }
    }//else Head oder null
  }

  public final Object dequeue(){

    if(stringCount != 0){
      return strings[stringCount--];
    }
    else{
      Object o = elems[0];
      System.arraycopy(elems, 1, elems, 0, --elementCount);
      return o;
    }
  }

  public final boolean isEmpty(){
    return elementCount == 0 & stringCount == 0;
  }

  public final String toString(){
    StringBuffer buf = new StringBuffer();

    //Die Strings
    if(stringCount >= 1){
      if(strings[0] != null)
	buf.append(elems[0].toString());
      else
	buf.append("null");

      for(int i= 1; i<stringCount;i++){
	if(strings[i] != null)
	  buf.append(", "+strings[i]);
	else
	  buf.append("null");
      }
    }

    //Die Heads 
    if(elementCount >= 1){
      if(elems[0] != null)
	buf.append(elems[0].toString());
      else
	buf.append("false ");

      for(int i= 1; i<elementCount;i++){
	if(elems[i] != null)
	  buf.append(", "+elems[i].toString());
	else
	  buf.append("false ");
      }
    }

    else if(stringCount==0 & elementCount==0) buf.append("[]");
    
    return buf.toString();
  }//toString

    /*
  public static void main(String args[]){
    Queue e = new Queue();

    for(int i=0; i<22;i++){
      e.enqueue(new Integer(i));
      System.out.println(e);
    }
    
    for(int i=0; i<22;i++){
      e.dequeue();
      System.out.println(e);
    }
    
    
    for(int i=0; i<22;i++){
      e.enqueue(new Integer(i));
      System.out.println(e);
    }
    System.out.println(e.isEmpty());
    e.empty();
    System.out.println(e.isEmpty());
    System.out.println(e);
  }
  */
    
}//class
