import java.util.*;

/**
 *Der Kopf der Clausel.<p>
 *Siehe auch <a href="SatchParserBNF.html"><b>SatchParserBNF.html</b></a>
 */
class Head{

  private Vector atome;
  private Vector atomClone = null;
  String instanceImage = null;

  Head(Vector at){
    atome = at;	 
  }

  Vector internVars(Vector v){

    for(int i=atome.size()-1;i>-1;i--)
      v = ((Atom) atome.elementAt(i)).internVars(v);

    return v;
  }

  /**
   *Gibt die Kopie des Head zurck, und lt die Variablenbindungen <strong>
   *dieses</strong> Heads unverndert.
   *
   *Zurckgegeben wird natrlich ein Head <strong>ohne</strong> gebundene
   * Variablen. Im Unterschied zum Klonen des Heads wird hier kein <code>
   *unbind</code> gemacht, und sollte auch nur dann aufgerufen werden, wenn 
   *man <strong>genau</strong> wei, was man tut. 
   */
  Head copy(){
    this.cloneYourValue();
    Head h = clonedValue();
    // this.unbind(); kein unbind machen, da wir damit noch backtracken wollen!
    return h;
  }

  void cloneYourValue(){

    atomClone = (Vector) atome.clone();

    for(int i= atome.size()-1;i>-1;i--){
      ((Atom) atome.elementAt(i)).cloneYourValue();
    }
  }

  Head clonedValue(){

    for(int i= atome.size()-1;i>-1;i--){
      atomClone.setElementAt(((Atom) atome.elementAt(i)).clonedValue(), i);
    }

    return new Head(atomClone);
  }

  void unbind(){
    for(int i= atome.size()-1;i>-1;i--){    
      ((Atom) atome.elementAt(i)).unbind();
    }
  }


  Vector getAtoms(){
    return atome;
  }

  public boolean equals(Object o){
    if(o instanceof Head){
      Vector v = ((Head) o).getAtoms();

      if(v.size() != atome.size()) 
	return false;

      for(int i=v.size()-1;i>-1;i--)
	if(!v.elementAt(i).equals(atome.elementAt(i)))
	  return false;

      return true;
    }
    return false;
  }

  /**
   *Wird bentigt um beim Erstellen der Trace-Datei ein Abbild der 
   *angewandten Instanz zu haben. Head ist dabei ein Zwischenspeicher.
   */
  void set_applied_instance_image(String img){
    instanceImage = img; 
  }

  /**
   *Wird bentigt um beim Erstellen der Trace-Datei ein Abbild der 
   *angewandten Instanz zu haben. Diese Methode gibt dieses Abbild zurck.
   */
  String applied_instance_image(){
    return instanceImage; 
  }

  int size(){
    return atome.size();
  }

  public String toString(){
    StringBuffer buf = new StringBuffer();

    if(atome.size() >0) 
      buf.append(atome.elementAt(0).toString());

    for(int i=1; i < atome.size();i++)
      buf.append("; "+atome.elementAt(i).toString());

    return buf.toString();
  }
}
